'////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
'  Copyright Syncfusion Inc. 2001 - 2003. All rights reserved. Use of this code is subject to the terms of our 
'  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
'  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
'////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 


Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms

Namespace GridControlSort


    ''' <summary>
    ''' Summary description for Form1.
    ''' </summary>
    Public Class Form1
        Inherits System.Windows.Forms.Form
        Private gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
        ''' <summary>
        ''' Required designer variable.
        ''' </summary>
        Private components As System.ComponentModel.Container = Nothing

        Public Sub New()
            '
            ' Required for Windows Form Designer support
            '
            InitializeComponent()

            '
            ' TODO: Add any constructor code after InitializeComponent call
            '
            gridControl1.ControllerOptions = gridControl1.ControllerOptions And Not(GridControllerOptions.OleDataSource Or GridControllerOptions.OleDropTarget)
            gridControl1.BaseStylesMap("Header").StyleInfo.Enabled = False
        End Sub

        ''' <summary>
        ''' Clean up any resources being used.
        ''' </summary>
        Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If components IsNot Nothing Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        #Region "Windows Form Designer generated code"
        ''' <summary>
        ''' Required method for Designer support - do not modify
        ''' the contents of this method with the code editor.
        ''' </summary>
        Private Sub InitializeComponent()
            Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl()
            CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            ' 
            ' gridControl1
            ' 
            Me.gridControl1.AllowDrop = True
            Me.gridControl1.Dock = System.Windows.Forms.DockStyle.Fill
            Me.gridControl1.Location = New System.Drawing.Point(0, 0)
            Me.gridControl1.Name = "gridControl1"
            Me.gridControl1.Size = New System.Drawing.Size(685, 212)
            Me.gridControl1.SmartSizeBox = False
            Me.gridControl1.TabIndex = 0
            Me.gridControl1.Text = "gridControl1"
            ' 
            ' Form1
            ' 
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(685, 212)
            Me.Controls.Add(Me.gridControl1)
            Me.Name = "Form1"
            Me.Text = "Sorting in a GridControl - Click a column header to sort that column"
'            Me.Load += New System.EventHandler(Me.Form1_Load)
            CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub
        #End Region

        ''' <summary>
        ''' The main entry point for the application.
        ''' </summary>
        <STAThread> _
        Public Shared Sub Main()
            Application.Run(New Form1())
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            PopulateTheGrid()

            'Turn off column selections - not absolutely needed but does simplify things
            Me.gridControl1.AllowSelection = GridSelectionFlags.Any And Not GridSelectionFlags.Column

            'Add a sort header to the CellModels... (in 1.0, only available by default in GridDataBoundGrid)
            Me.gridControl1.CellModels.Add("ColumnHeaderCell", New GridSortColumnHeaderCellModel(Me.gridControl1.Model))

            'Catch the click
            AddHandler gridControl1.CellClick, AddressOf HandleAClick

        End Sub

        Private Sub PopulateTheGrid()
            Dim r As New Random()
            Me.gridControl1.CommandStack.Enabled = False
            Me.gridControl1.BeginUpdate()
            For row As Integer = 1 To Me.gridControl1.RowCount
                For col As Integer = 1 To Me.gridControl1.ColCount
                    If col = 2 Then
                        Dim dt As New DateTime(r.Next(50) + 1960, r.Next(11) + 1, r.Next(27) + 1)
                        Me.gridControl1(row, col).CellValue = dt
                    ElseIf col = 4 Then
                        Me.gridControl1(row, col).CellValue = RandomString(r)
                    ElseIf col = 6 Then
                        Me.gridControl1(row, col).CellValue = (If((r.Next(2) = 0), 1, - 1)) * (CSng(r.Next(100000)))/ 200
                    Else
                        Me.gridControl1(row, col).CellValue = (If((r.Next(2) = 0), 1, - 1)) * r.Next(1000)
                    End If
                Next col

            Next row

            Me.gridControl1.DefaultColWidth = 50
            'this.gridControl1.TableStyle.HorizontalAlignment = GridHorizontalAlignment.Center;

            'Column 2 is a date column
            Me.gridControl1.ColStyles(2).CellValueType = GetType(DateTime)
            Me.gridControl1.ColStyles(2).Format = "dd MMM yyyy"
            Me.gridControl1.ColWidths(2) = 100
            Me.gridControl1(0, 2).Text = "Date"

            'Column 4 is text
            Me.gridControl1.ColWidths(4) = 100
            Me.gridControl1(0, 4).Text = "Text"

            'Column 6 is a float column
            Me.gridControl1.ColStyles(6).CellValueType = GetType(Single)
            Me.gridControl1.ColStyles(6).Format = "####.##"
            Me.gridControl1.ColWidths(6) = 100
            Me.gridControl1(0, 6).Text = "floats"

            Me.gridControl1.EndUpdate()
            Me.gridControl1.Refresh()
        End Sub

        Private Sub HandleAClick(ByVal sender As Object, ByVal e As GridCellClickEventArgs)
            If e.MouseEventArgs.Button = MouseButtons.Left AndAlso e.RowIndex = 0 AndAlso e.ColIndex > 0 Then
                SortCol(e.ColIndex)
            End If

        End Sub

        Public Sub SortCol(ByVal col As Integer)
            If Me.gridControl1.CurrentCell.IsEditing Then
                Me.gridControl1.CurrentCell.EndEdit()
            End If

            Dim style As New GridStyleInfo()
            style.Tag = ""

            'Turn off the old sort arrow
            For col1 As Integer = 1 To Me.gridControl1.ColCount
                If col1 <> col AndAlso Me.gridControl1(0, col1).CellType Is "ColumnHeaderCell" Then
                    Me.gridControl1(0, col1).CellType = "Header"
                    Exit For
                End If
            Next col1

            'Turn on new sort arrow
            Me.gridControl1(0, col).CellType = "ColumnHeaderCell"

            If Me.gridControl1(0, col).HasTag Then
                If CType(Me.gridControl1(0, col).Tag, ListSortDirection) = ListSortDirection.Ascending Then
                    Me.gridControl1(0, col).Tag = ListSortDirection.Descending
                Else
                    Me.gridControl1(0, col).Tag = ListSortDirection.Ascending
                End If
            Else
                Me.gridControl1(0, col).Tag = ListSortDirection.Ascending
            End If

            If col = 4 Then
                Me.gridControl1.Data.SortByColumn(col,CType(Me.gridControl1(0, col).Tag, ListSortDirection), New StrLenComparer())
            Else
                Me.gridControl1.Data.SortByColumn(col,CType(Me.gridControl1(0, col).Tag, ListSortDirection))
            End If

            Me.gridControl1.Refresh()
        End Sub

        Private Function RandomString(ByVal r As Random) As String
            Dim len As Integer = r.Next(12) + 1
            Dim sb As New System.Text.StringBuilder(len)

            For i As Integer = 0 To len - 1
                sb.Append(ChrW(r.Next(26) + 65))
            Next i

            Return sb.ToString()

        End Function

    End Class
    Public Class StrLenComparer
        Implements IComparer

        #Region "Implementation of IComparer"
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            If x Is Nothing AndAlso y Is Nothing Then
                Return 0
            ElseIf x Is Nothing Then
                Return 1
            ElseIf y Is Nothing Then
                Return -1
            Else
                If x.ToString().Length > y.ToString().Length Then
                    Return -1
                End If
                If x.ToString().Length < y.ToString().Length Then
                    Return 1
                Else
                    Return 0
                End If
            End If
        End Function

        #End Region
    End Class
End Namespace
